import java.awt.event.ActionEvent;
import java.util.Random;

public class Game extends Thread {
	final static int numplayers=4;
	final static int winningpoints=15;
	final static boolean output = true;
	protected Player[] player= new Player[numplayers];
	Deck deck = new Deck();
	protected Card[] cards = new Card[Card.SUITS*Card.NUMCARDS];
	int curnumcards = 0;
	boolean gameover = false;
	static Card highestcard=null;
	protected static Random generator = new Random(); // Lets all use one generator.
	protected Main m1;
	private int delay = 2000;
	
	public Game(Main m1)
	{
		this.m1 = m1;
		// Create players, and give them their names.
		//for (int i=0; i<numplayers; i++)
		
		player[0] = new RandomPlayer("Random 1");
		player[1] = new GreedyPlayer("Greedy 1");
		player[3] = new FeebleMindPlayer("FeebleMind 1");
		player[2] = new ReasoningPlayer("Reasoning 1");
			
		/*dealCards();
		//deck.dumpCards();
		playGame();*/
		
	
		//playEntire();
	}
	
	
	public Player[] getPlayers()
	{
		
		return player;
	}
	
	public void reset()
	{
		curnumcards =0;
		deck.reset();
		for (int i=0; i<numplayers; i++)
			player[i].reset();
		dealCards();
		
	}
	
	public void setDelay(int delay)
	{
		this.delay = delay;		
	}
	
	public synchronized void run() {
		// Test if there is a bias over 1000 games.
		int scores[] = new int[numplayers];
		for (int i=0; i<numplayers; i++)
			scores[i] = 0;
		for (int i=0; i<1; i++) // THIS IS THE NUMBER OF GAMES.
		{
			gameover=false;
			scores[playEntire()]++;
		}
		for (int i=0; i<numplayers; i++)
		{
			if(scores[i] > 0)
				m1.writeToConsole("Player "+player[i].getName()+" has won.");	        
		}
		
		m1.gameEnded();
	}
	
	
	public int playEntire()
	{
		int winningplayer = -1;
		for (int i=0; i<numplayers; i++)
			player[i].resetPoints();
		
		while (!gameover)
		{
			reset();
			winningplayer=playGame();
			if (output)
			{
				m1.writeToConsole("----------------------------------");
				for (int j=0; j<numplayers; j++)	
					m1.writeToConsole("Player "+player[j].getName()+" has "+player[j].getPoints()+" points");
	
				m1.writeToConsole("----------------------------------");
				}
		}
		int minindex =0;
		int minscore = winningpoints;
		// LET OP! (TODO) - In geval van gelijke laagste scores, wint de eerste player met deze score.
		for (int j=0; j<numplayers; j++)
			if (player[j].getPoints() < minscore)
			{
				minscore = player[j].getPoints();
				minindex = j;
			}
		// Check voor deze dubbele.
		
			
		return minindex;
	}
	
	public int playGame()
	{
		//		 Play the rounds!
		int currentstake = 1;
		int curplayer=generator.nextInt(numplayers);
		int winningplayerid=-2;
		// rounds
		for (int i=0; i<4; i++)
		{
			highestcard=null;
			winningplayerid=-1;
			int suit=-1;
			// Players
			for (int j=0; j<numplayers; j++)
			{	
				//cards[curnumcards] = player[curplayer].drawCard("Table");
				// Beware! the curnumcards card hasn't been player yet.
				cards[curnumcards] = player[curplayer].drawCard("Table",cards,curnumcards,i,j);
				m1.repaint();
				try
				{
					Thread.sleep(delay);				
				}
				catch(Exception e)
				{
					e.printStackTrace();
				}				
				if (suit == -1) // determine the suit.
					suit = cards[curnumcards].getSuit();
				if (output) System.out.println("Player "+player[curplayer].getName()+" Played "+cards[curnumcards].getDescription());
				// Card is the winning card of the round if its: a) the first card, b)higher than the previous highest card, and has the correct suit. 
				if ( (highestcard==null) || ((cards[curnumcards].getValue() > highestcard.getValue()) && (cards[curnumcards].getSuit() == suit)))
				{
					highestcard = cards[curnumcards];
					winningplayerid = curplayer;
				}
				curnumcards++;
				curplayer++;
				if (curplayer == numplayers)
					curplayer = 0;
			}
			if (output) System.out.println("Player "+player[winningplayerid].getName()+" wins the "+i+"th round with "+highestcard.getDescription());
			curplayer = winningplayerid;

		}
		// Handle winning.
		if (output) m1.writeToConsole("Player "+player[winningplayerid].getName()+" Wins the game with "+highestcard.getDescription());
		for (int j=0; j<numplayers; j++)
			if (j != winningplayerid)
			{
				player[j].addpoints(currentstake);
				if ( player[j].getPoints() >= winningpoints)
					gameover = true;
			}
		
		
		return winningplayerid;
	}
	
	//	 Deal the cards.
	public void dealCards()
	{
		
		for (int i=0; i<numplayers; i++)
			for (int j=0; j<Player.MAXNUMCARDS; j++)
				player[i].giveCard(deck.drawCard(""+j));
	}
	
}
